export interface CartesianCoordinate {
    x: number;
    y: number;
    z?: number;
}
export declare class PageVector {
    from: CartesianCoordinate;
    to: CartesianCoordinate;
    constructor(from: CartesianCoordinate, to: CartesianCoordinate);
    get length(): number;
    get direction(): "forward" | "backward" | "right" | "left" | "up" | "down";
}
export declare function getSwipeVector(from: CartesianCoordinate, to: CartesianCoordinate, threshold?: number): PageVector;
export interface AnimationEvents {
    transition: TransitionEvent;
    animation: AnimationEvent;
}
export declare type AnimationType = keyof AnimationEvents;
export declare function durationOf(type: AnimationType, element: HTMLElement): number;
export declare function watchMotion<T extends AnimationType>(type: T, element: HTMLElement): Promise<void | AnimationEvents[T]>;
export declare function transitIn(element: HTMLElement, className: string, display?: string): Promise<void | TransitionEvent>;
export declare function animateIn(element: HTMLElement, className: string, display?: string): Promise<void | AnimationEvent>;
export declare function transitOut(element: HTMLElement, className: string, remove?: boolean): Promise<void>;
export declare function animateOut(element: HTMLElement, className: string, remove?: boolean): Promise<void>;
